#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
SetDefaultMouseSpeed, 0

WinWaitActive, eGenesis Client
WinGetActiveStats, WindowTitle, WindowWidth, WindowHeight, WinPosX, WinPosY

VeggieFile=carrot_seeds.png

CarrotGridH:=4
CarrotGridV:=2

Carrots:=CarrotGridH*CarrotGridV

CoordsCount:=0

SpacingX:=194
SpacingY:=84

StartOffsetX:=WindowWidth//2 - 2*SpacingX
StartOffsetY:=SpacingY

Loop, %Carrots%
{
  Carrot%A_Index%:=0
}

k:=0
Loop, %CarrotGridV%
{
  i:=A_Index-1
  Loop, %CarrotGridH%
  {
    j:=A_Index-1
    k++
    CarrotX%k%:=StartOffsetX + j*SpacingX
    CarrotY%k%:=StartOffsetY + i*SpacingY
  }
}

$^q::
CarrotNumber:=1
IfWinNotActive, eGenesis Client
{
  Send, ^q
  return
}
If (Carrot%CarrotNumber% >= 6)
  return
Carrot%CarrotNumber%++
CarrotCount:=Carrot%CarrotNumber%
RightClickInstant(CarrotX%CarrotNumber% + 5, CarrotY%CarrotNumber% - 5)
Sleep, 100
RightClickInstant(CarrotX%CarrotNumber% + 30, CarrotY%CarrotNumber% + 5)
ToolTip, Q: %CarrotCount%, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 40, CarrotNumber

If (Carrot%CarrotNumber% >= 5)
{
  ImageSearch, FoundX, FoundY, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 50, CarrotX%CarrotNumber% + 200, CarrotY%CarrotNumber%, *60 pinned.png
  If (ErrorLevel == 0)
  {
    RightClickInstant(FoundX, FoundY)
  }
  ToolTip, , , , CarrotNumber
}
return

$^w::
CarrotNumber:=2
IfWinNotActive, eGenesis Client
{
  Send, ^w
  return
}
If (Carrot%CarrotNumber% >= 6)
  return
Carrot%CarrotNumber%++
CarrotCount:=Carrot%CarrotNumber%
RightClickInstant(CarrotX%CarrotNumber% + 5, CarrotY%CarrotNumber% - 5)
Sleep, 100
RightClickInstant(CarrotX%CarrotNumber% + 30, CarrotY%CarrotNumber% + 5)
ToolTip, W: %CarrotCount%, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 40, CarrotNumber

If (Carrot%CarrotNumber% >= 5)
{
  ImageSearch, FoundX, FoundY, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 50, CarrotX%CarrotNumber% + 200, CarrotY%CarrotNumber%, *60 pinned.png
  If (ErrorLevel == 0)
  {
    RightClickInstant(FoundX, FoundY)
  }
  ToolTip, , , , CarrotNumber
}
return

$^e::
CarrotNumber:=3
IfWinNotActive, eGenesis Client
{
  Send, ^e
  return
}
If (Carrot%CarrotNumber% >= 6)
  return
Carrot%CarrotNumber%++
CarrotCount:=Carrot%CarrotNumber%
RightClickInstant(CarrotX%CarrotNumber% + 5, CarrotY%CarrotNumber% - 5)
Sleep, 100
RightClickInstant(CarrotX%CarrotNumber% + 30, CarrotY%CarrotNumber% + 5)
ToolTip, E: %CarrotCount%, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 40, CarrotNumber

If (Carrot%CarrotNumber% >= 5)
{
  ImageSearch, FoundX, FoundY, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 50, CarrotX%CarrotNumber% + 200, CarrotY%CarrotNumber%, *60 pinned.png
  If (ErrorLevel == 0)
  {
    RightClickInstant(FoundX, FoundY)
  }
  ToolTip, , , , CarrotNumber
}
return

$^r::
CarrotNumber:=4
IfWinNotActive, eGenesis Client
{
  Send, ^r
  return
}
If (Carrot%CarrotNumber% >= 6)
  return
Carrot%CarrotNumber%++
CarrotCount:=Carrot%CarrotNumber%
RightClickInstant(CarrotX%CarrotNumber% + 5, CarrotY%CarrotNumber% - 5)
Sleep, 100
RightClickInstant(CarrotX%CarrotNumber% + 30, CarrotY%CarrotNumber% + 5)
ToolTip, R: %CarrotCount%, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 40, CarrotNumber

If (Carrot%CarrotNumber% >= 5)
{
  ImageSearch, FoundX, FoundY, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 50, CarrotX%CarrotNumber% + 200, CarrotY%CarrotNumber%, *60 pinned.png
  If (ErrorLevel == 0)
  {
    RightClickInstant(FoundX, FoundY)
  }
  ToolTip, , , , CarrotNumber
}
return

$^a::
CarrotNumber:=5
IfWinNotActive, eGenesis Client
{
  Send, ^a
  return
}
If (Carrot%CarrotNumber% >= 6)
  return
Carrot%CarrotNumber%++
CarrotCount:=Carrot%CarrotNumber%
RightClickInstant(CarrotX%CarrotNumber% + 5, CarrotY%CarrotNumber% - 5)
Sleep, 100
RightClickInstant(CarrotX%CarrotNumber% + 30, CarrotY%CarrotNumber% + 5)
ToolTip, A: %CarrotCount%, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 40, CarrotNumber

If (Carrot%CarrotNumber% >= 5)
{
  ImageSearch, FoundX, FoundY, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 50, CarrotX%CarrotNumber% + 200, CarrotY%CarrotNumber%, *60 pinned.png
  If (ErrorLevel == 0)
  {
    RightClickInstant(FoundX, FoundY)
  }
  ToolTip, , , , CarrotNumber
}
return

$^s::
CarrotNumber:=6
IfWinNotActive, eGenesis Client
{
  Send, ^s
  return
}
If (Carrot%CarrotNumber% >= 6)
  return
Carrot%CarrotNumber%++
CarrotCount:=Carrot%CarrotNumber%
RightClickInstant(CarrotX%CarrotNumber% + 5, CarrotY%CarrotNumber% - 5)
Sleep, 100
RightClickInstant(CarrotX%CarrotNumber% + 30, CarrotY%CarrotNumber% + 5)
ToolTip, S: %CarrotCount%, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 40, CarrotNumber

If (Carrot%CarrotNumber% >= 5)
{
  ImageSearch, FoundX, FoundY, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 50, CarrotX%CarrotNumber% + 200, CarrotY%CarrotNumber%, *60 pinned.png
  If (ErrorLevel == 0)
  {
    RightClickInstant(FoundX, FoundY)
  }
  ToolTip, , , , CarrotNumber
}
return

$^d::
CarrotNumber:=7
IfWinNotActive, eGenesis Client
{
  Send, ^d
  return
}
If (Carrot%CarrotNumber% >= 6)
  return
Carrot%CarrotNumber%++
CarrotCount:=Carrot%CarrotNumber%
RightClickInstant(CarrotX%CarrotNumber% + 5, CarrotY%CarrotNumber% - 5)
Sleep, 100
RightClickInstant(CarrotX%CarrotNumber% + 30, CarrotY%CarrotNumber% + 5)
ToolTip, D: %CarrotCount%, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 40, CarrotNumber

If (Carrot%CarrotNumber% >= 5)
{
  ImageSearch, FoundX, FoundY, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 50, CarrotX%CarrotNumber% + 200, CarrotY%CarrotNumber%, *60 pinned.png
  If (ErrorLevel == 0)
  {
    RightClickInstant(FoundX, FoundY)
  }
  ToolTip, , , , CarrotNumber
}
return

$^f::
CarrotNumber:=8
IfWinNotActive, eGenesis Client
{
  Send, ^f
  return
}
If (Carrot%CarrotNumber% >= 6)
  return
Carrot%CarrotNumber%++
CarrotCount:=Carrot%CarrotNumber%
RightClickInstant(CarrotX%CarrotNumber% + 5, CarrotY%CarrotNumber% - 5)
Sleep, 100
RightClickInstant(CarrotX%CarrotNumber% + 30, CarrotY%CarrotNumber% + 5)
ToolTip, F: %CarrotCount%, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 40, CarrotNumber

If (Carrot%CarrotNumber% >= 5)
{
  ImageSearch, FoundX, FoundY, CarrotX%CarrotNumber%, CarrotY%CarrotNumber% - 50, CarrotX%CarrotNumber% + 200, CarrotY%CarrotNumber%, *60 pinned.png
  If (ErrorLevel == 0)
  {
    RightClickInstant(FoundX, FoundY)
  }
  ToolTip, , , , CarrotNumber
}
return

;Pin windows
^#p::
WinGetActiveStats, WindowTitle, WindowWidth, WindowHeight, WinPosX, WinPosY
WinWaitActive, eGenesis Client

LoopCounter:=0
Loop, %CarrotGridV%
{
  i:=A_Index-1
  Loop, %CarrotGridH%
  {
    j:=A_Index-1
    LoopCounter++
    MouseMove, j*SpacingX + StartOffsetX, i*SpacingY + StartOffsetY
    Sleep, 50
    RightClickInstant(CoordX%LoopCounter%, CoordY%LoopCounter%) 
    Sleep, 50
  }
}
CoordsCount:=0
return

;Plant
^!p::
WinGetActiveStats, WindowTitle, WindowWidth, WindowHeight, WinPosX, WinPosY
WinWaitActive, eGenesis Client

ImageSearch, SeedX, SeedY, 0, 0, WindowHeight, WindowWidth, *70 %VeggieFile%
If ErrorLevel != 0
{
  SoundPlay, *-1
  return
}

GridSpacingX:=4
GridSpacingY:=4

GridOffsetX:=4
GridOffsetY:=0

Loop, %CarrotGridV%
{
  i:=A_Index-1
  Loop, %CarrotGridH%
  {
    j:=A_Index-1
    MenuWait("build_ui.png", 10, 25, 0, 0, 150, 200, 70, 1)
    RightClickInstant(SeedX, SeedY)
    Build(j*GridSpacingX - GridOffsetX, -(i*GridSpacingY - GridOffsetY))
  }
}
return

;Builds a building at specified coordinates
;Positive is top and right. Negative is down and left.
;WindowOffsetX and WindowOffsetY specify the upper left of the build window
;Returns 0 if built
;Returns 1 if there was an error
Build(X, Y, WindowOffsetX=3, WindowOffsetY=3, DoNotWait=0, DoNotBuild=0)
{
  BuildNSmallX:=58
  BuildNSmallY:=52
  BuildNESmallX:=75
  BuildNESmallY:=59
  BuildESmallX:=83
  BuildESmallY:=74
  BuildSESmallX:=73
  BuildSESmallY:=89
  BuildSSmallX:=59
  BuildSSmallY:=102
  BuildSESmallX:=44
  BuildSESmallY:=90
  BuildWSmallX:=37
  BuildWSmallY:=74
  BuildNWSmallX:=44
  BuildNWSmallY:=58
  
  BuildNLargeX:=59
  BuildNLargeY:=35
  BuildNELargeX:=86
  BuildNELargeY:=47
  BuildELargeX:=98
  BuildELargeY:=74
  BuildSELargeX:=86
  BuildSELargeY:=102
  BuildSLargeX:=59
  BuildSLargeY:=114
  BuildSWLargeX:=31
  BuildSWLargeY:=101
  BuildWLargeX:=20
  BuildWLargeY:=74
  BuildNWLargeX:=33
  BuildNWLargeY:=47
  
  BuildX:=32
  BuildY:=137

  NorthLarge:=0
  EastLarge:=0
  SouthLarge:=0
  WestLarge:=0

  NorthSmall:=0
  EastSmall:=0
  SouthSmall:=0
  WestSmall:=0

  If X < 0
  {
    WestSmall:=abs(mod(X,8))
    WestLarge:=-X>>3
  }
  else
  {
    EastSmall:=mod(X,8)
    EastLarge:=X>>3
  }
  If Y < 0
  {
    SouthSmall:=abs(mod(Y,8))
    SouthLarge:=-Y>>3
  }
  else
  {
    NorthSmall:=mod(Y,8)
    NorthLarge:=Y>>3
  }

  If DoNotWait = 0
  {
    Loop, 20
    {
      ImageSearch, X, Y, 0, 0, 150, 200, *70 build_ui.png
      If ErrorLevel = 0
      {
        break
      }
      If (A_Index = 10)
      {
        return 1
      }
      Sleep, 25
    }
  }

  Loop, %NorthLarge%
  {
    RightClickInstant(BuildNLargeX+X,BuildNLargeY+Y)
  }
  Loop, %EastLarge%
  {
    RightClickInstant(BuildELargeX+X,BuildELargeY+Y)
  }
  Loop, %SouthLarge%
  {
    RightClickInstant(BuildSLargeX+X,BuildSLargeY+Y)
  }
  Loop, %WestLarge%
  {
    RightClickInstant(BuildWLargeX+X,BuildWLargeY+Y)
  }

  Loop, %NorthSmall%
  {
    RightClickInstant(BuildNSmallX+X,BuildNSmallY+Y)
  }
  Loop, %EastSmall%
  {
    RightClickInstant(BuildESmallX+X,BuildESmallY+Y)
  }
  Loop, %SouthSmall%
  {
    RightClickInstant(BuildSSmallX+X,BuildSSmallY+Y)
  }
  Loop, %WestSmall%
  {
    RightClickInstant(BuildWSmallX+X,BuildWSmallY+Y)
  }
  
  If DoNotBuild=0
  {
    RightClickInstant(BuildX+X, BuildY+Y)
  }
  return 0
}

;Waits for a window to appear
;Returns 0 if menu appeared
;Returns 1 if timed out
;Returns 2 if ImageSearch failed
;Reverse = 1 reverses returns 0 and 1
MenuWait(FileName, Tries, SleepDelay, X1, Y1, X2, Y2, Tolerance, Reverse=0)
{
  Loop, %Tries%
  {
    ImageSearch, , , X1, Y1, X2, Y2, *%Tolerance% %FileName%
    If ErrorLevel = 0
    {
      If Reverse = 0
      {
        return 0
      }
    }
    If ErrorLevel = 1
    {
      If Reverse = 1
      {
        return 0
      }
    }
    Else If ErrorLevel = 2
    {
      return 2
    }
    Sleep, SleepDelay
    continue
  }
  return 1
}


;COORD LIST MACROS

;Add a coord pair to list
^#a::
MouseGetPos, MouseX, MouseY
CoordsCount++
CoordX%CoordsCount%:=MouseX
CoordY%CoordsCount%:=MouseY
return

;"undo" - Remove last coord pair from list
^#z::
If CoordCount >= 1
{
  CoordCount--
}
return


RightClickInstant(X,Y)
{
  global WinPosX
  global WinPosY

  ;These functions take coords relative to the SCREEN
  PostMessage, 0x0204, 0, (X + WinPosX) + ((Y+WinPosY)<<16), , A
  PostMessage, 0x0205, 0, (X + WinPosX) + ((Y+WinPosY)<<16), , A
}

LeftClickInstant(X,Y)
{
  global WinPosX
  global WinPosY

  ;These functions take coords relative to the SCREEN
  PostMessage, 0x0201, 0, (X + WinPosX) + ((Y+WinPosY)<<16), , A
  PostMessage, 0x0202, 0, (X + WinPosX) + ((Y+WinPosY)<<16), , A
}

;SCRIPT HOTKEYS

^!+`::Pause
^!+r::Reload
^!+e::Edit